
!UiTreeView methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 18:05:14.956'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: aModelIndex) do: [:row |
		1 to: (self model columnCountFor: aModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			aBoolean ifTrue: [item fadeIn]]].! !

!UiTreeView methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 18:05:08.738'!
resetHeaderItems

	| index item |
	self model ifNil: [^ self].
	"1 to: (self model rowCountFor: nil) do: [:row |
		index := self model indexRow: row column: 0 parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		item width: verticalHeader width.
		self viewport setHeaderItem: item atRow: row]."
	
	1 to: (self model columnCountFor: nil) do: [:col |
		index := self model indexRow: 0 column: col parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		horizontalHeader height: (horizontalHeader height max: item height).
		self viewport setHeaderItem: item atColumn: col].! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:51:31.693'!
clear

	items removeAll.! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:54:55.353'!
cellBoundsFor: aCellIndex

	| col row |
	(aCellIndex x > columns size
		or: [aCellIndex y > rows size])
		ifTrue: [^ 0@0 extent: 0@0].
	
	col := columns at: aCellIndex x.
	row := rows at: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:56:54.347'!
clear

	self currentCell: nil.
	self selection clear.
	
	columns do: [:colInfo | colInfo clear].
	rows removeAll.
	self removeAllMorphs.! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:58:53.347'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := columns at: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 18:03:26.013'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns ifEmpty: [^ self].
	
	columns first width < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first ifNil: [first := 1@1].
	last ifNil: [last := 1@rows size].
	
	last < first ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| item cellBounds form |
		cellBounds := self cellBoundsFor: 1@rowIndex.
		item := (rows at: rowIndex) items first.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 18:00:37.316'!
keyStroke: evt

	"Manuall navigation."
	self currentCell ifNil: [^ self currentCell: 1@1].

	evt keyCharacter = Character arrowUp
		ifTrue: [self currentCell: (self currentCell - (0@1) max: 1@1)].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self currentCell: (self currentCell + (0@1) min: (columns size @ rows size) max: 1@1)].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self currentCell: (self currentCell - (1@0) max: 1@1)].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self currentCell: (self currentCell + (1@0) min: (columns size @ rows size) max: 1@1)].
		
	self selection
		add: self currentCell
		event: evt.! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:58:29.235'!
rowBoundsFor: aRowIndex

	| row |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
		
	row := rows at: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiTreeViewport methodsFor: 'geometry' stamp: 'mt 10/11/2010 18:07:00.708'!
updateExtent

	self extent:
		(columns
			ifEmpty: [0]
			ifNotEmpty: [(columns collect: [:col | col width]) sum])
		@
		(rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum])! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 17:57:02.818'!
clear
! !

!UiViewSingleSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 17:57:25.989'!
clear

	selectedCell := nil.
	self selectionChanged.! !
