
!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/9/2010 12:12:42.836'!
cellBoundsFor: aCellIndex

	| col row |
	col := columns at: aCellIndex x.
	row := rows at: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/10/2010 10:38:05.429'!
clear

	columns do: [:colInfo | colInfo clear].
	rows removeAll.
	self removeAllMorphs.! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 09:20:27.893'!
columnBoundsFor: aColIndex

	| col |
	col := columns at: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/10/2010 11:56:07.146'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns first width < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first isNil | last isNil ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| item cellBounds form |
		cellBounds := self cellBoundsFor: 1@rowIndex.
		item := (rows at: rowIndex) items first.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 17:17:04.271'!
keyStroke: evt

	evt keyCharacter = Character arrowUp
		ifTrue: [self currentCell: (self currentCell - (0@1) max: 1@1)].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self currentCell: (self currentCell + (0@1) min: (columns size @ rows size))].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self currentCell: (self currentCell - (1@0) max: 1@1)].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self currentCell: (self currentCell + (1@0) min: (columns size @ rows size))].
		
	self selection
		add: self currentCell
		event: evt.! !

!UiTreeViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 09:17:00.054'!
rowBoundsFor: aRowIndex

	| row |
	row := rows at: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiTreeViewport methodsFor: 'geometry' stamp: 'mt 10/9/2010 12:49:47.63'!
updateExtent

	self extent:
		(columns collect: [:col | col width]) sum
		@
		(rows collect: [:row | row height]) sum! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/10/2010 10:37:32.512'!
clear

	items removeAll.
	size := nil.! !

!UiTreeView methodsFor: 'as yet unclassified' stamp: 'mt 10/10/2010 13:53:09.012'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	
	1 to: (self model rowCountFor: aModelIndex) do: [:row |
		1 to: (self model columnCountFor: aModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			aBoolean ifTrue: [item fadeIn]]].! !

!UiTreeView methodsFor: 'as yet unclassified' stamp: 'mt 10/10/2010 14:17:03.592'!
resetHeaderItems

	| index item |	
	"1 to: (self model rowCountFor: nil) do: [:row |
		index := self model indexRow: row column: 0 parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		item width: verticalHeader width.
		self viewport setHeaderItem: item atRow: row]."
	
	1 to: (self model columnCountFor: nil) do: [:col |
		index := self model indexRow: 0 column: col parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		horizontalHeader height: (horizontalHeader height max: item height).
		self viewport setHeaderItem: item atColumn: col].! !
